# coding: utf-8

"""
    OurSky Astro

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.3.1905
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr
from ourskyai_astro_api.models.filter_type import FilterType
from ourskyai_astro_api.models.tracking_type import TrackingType

class V1ImageSet(BaseModel):
    """
    An image set represents a contiguous set of observations of the same target captured by the same node.  # noqa: E501
    """
    id: StrictStr = Field(...)
    target_id: Optional[StrictStr] = Field(None, alias="targetId")
    ra: Optional[Union[StrictFloat, StrictInt]] = None
    dec: Optional[Union[StrictFloat, StrictInt]] = None
    node_id: StrictStr = Field(..., alias="nodeId")
    observation_id: Optional[StrictStr] = Field(None, alias="observationId")
    tracking_type: TrackingType = Field(..., alias="trackingType")
    filter_type: Optional[FilterType] = Field(None, alias="filterType")
    created_at: datetime = Field(..., alias="createdAt")
    updated_at: Optional[datetime] = Field(None, alias="updatedAt")
    oursky_plugin_version: Optional[StrictStr] = Field(None, alias="ourskyPluginVersion")
    __properties = ["id", "targetId", "ra", "dec", "nodeId", "observationId", "trackingType", "filterType", "createdAt", "updatedAt", "ourskyPluginVersion"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1ImageSet:
        """Create an instance of V1ImageSet from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1ImageSet:
        """Create an instance of V1ImageSet from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1ImageSet.parse_obj(obj)

        _obj = V1ImageSet.parse_obj({
            "id": obj.get("id"),
            "target_id": obj.get("targetId"),
            "ra": obj.get("ra"),
            "dec": obj.get("dec"),
            "node_id": obj.get("nodeId"),
            "observation_id": obj.get("observationId"),
            "tracking_type": obj.get("trackingType"),
            "filter_type": obj.get("filterType"),
            "created_at": obj.get("createdAt"),
            "updated_at": obj.get("updatedAt"),
            "oursky_plugin_version": obj.get("ourskyPluginVersion")
        })
        return _obj


